Bug 1897536 - python-bitarray fails to build with Python 3.10: Py_TYPE=/Py_SIZE= needs to be replaced with Py_SET_TYPE/Py_SET_SIZE
Summary: python-bitarray fails to build with Python 3.10: Py_TYPE=/Py_SIZE= needs to b...
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Fedora
Classification: Fedora
Component: python-bitarray
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Nick Bebout
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-13 11:38 UTC by Tomáš Hrnčiar
Modified: 2020-11-19 10:28 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-11-18 19:49:00 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-11-13 11:38:58 UTC
python-bitarray fails to build with Python 3.10.0a2.

bitarray/_bitarray.c:126:23: error: lvalue required as left operand of assignment
  126 |         Py_SIZE(self) = newsize;
      |                       ^
bitarray/_bitarray.c:151:19: error: lvalue required as left operand of assignment
  151 |     Py_SIZE(self) = newsize;
      |                   ^
bitarray/_bitarray.c: In function ‘newbitarrayobject’:
bitarray/_bitarray.c:172:18: error: lvalue required as left operand of assignment
  172 |     Py_SIZE(obj) = nbytes;
      |                  ^
bitarray/_bitarray.c: In function ‘bitarray_fromfile’:
bitarray/_bitarray.c:1429:5: warning: ‘PyEval_CallObjectWithKeywords’ is deprecated [-Wdeprecated-declarations]
 1429 |     result = PyEval_CallObject(reader, rargs);
      |     ^~~~~~
In file included from /usr/include/python3.10/Python.h:146,
                 from bitarray/_bitarray.c:12:

bitarray/_bitarray.c: In function ‘PyInit__bitarray’:
bitarray/_bitarray.c:3273:28: error: lvalue required as left operand of assignment
 3273 |     Py_TYPE(&Bitarraytype) = &PyType_Type;
      |                            ^
bitarray/_bitarray.c:3274:31: error: lvalue required as left operand of assignment
 3274 |     Py_TYPE(&SearchIter_Type) = &PyType_Type;
      |                               ^
bitarray/_bitarray.c:3275:31: error: lvalue required as left operand of assignment
 3275 |     Py_TYPE(&DecodeIter_Type) = &PyType_Type;
      |                               ^
bitarray/_bitarray.c:3276:33: error: lvalue required as left operand of assignment
 3276 |     Py_TYPE(&BitarrayIter_Type) = &PyType_Type;
      |                                 ^
error: command '/usr/bin/gcc' failed with exit code 1
error: Bad exit status from /var/tmp/rpm-tmp.Y1id3w (%build)

https://docs.python.org/3.10/whatsnew/3.10.html#id2

Since Py_TYPE() is changed to the inline static function, Py_TYPE(obj) = new_type must be replaced with Py_SET_TYPE(obj, new_type): see Py_SET_TYPE() (available since Python 3.9). For backward compatibility, this macro can be used:

#if PY_VERSION_HEX < 0x030900A4
#  define Py_SET_TYPE(obj, type) ((Py_TYPE(obj) = (type)), (void)0)
#endif
https://bugs.python.org/issue39573

https://docs.python.org/3.10/whatsnew/changelog.html#id11

bpo-39573: Convert Py_REFCNT() and Py_SIZE() macros to static inline functions. They cannot be used as l-value anymore: use Py_SET_REFCNT() and Py_SET_SIZE() to set an object reference count and size. This change is backward incompatible on purpose, to prepare the C API for an opaque PyObject structure.
https://bugs.python.org/issue39573

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01757320-python-bitarray/

For all our attempts to build python-bitarray with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-bitarray/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Miro Hrončok 2020-11-18 17:57:13 UTC
The change was reverted in Python 3.10, because it caused too much trouble (the amount of affected Fedora packages was too big). Keeping this open for now, unit  anew alpha version is out to test it out.

This comment is mass posted in all relevant bugzillas. If you already worked upstream to fix the problem, please let them know about the revert.

https://github.com/python/cpython/commit/0e2ac21dd

Comment 2 Miro Hrončok 2020-11-18 19:49:00 UTC
I've patched Python 3.10 in our testing copr to include the revert. This package built fine. Sorry for the noise.

Comment 3 Sergio Basto 2020-11-19 10:28:58 UTC
JFYI I updated python-bitarray to 1.6.1


Note You need to log in before you can comment on or make changes to this bug.